function getMyDSID() {
	return Property.getProperty('/system/dSID');
}

function getDSMPIDForZone(zoneID) {
	lInfo.logln('deteminate dsm for ' + zoneID);
	var oPossibleCircuits = [];
	var pidCircuits = {};
	var odSMArray = Property.getNode('/apartment/dSMeters').getChildren();
	for ( var iIndex = 0; iIndex < odSMArray.length; iIndex++) {
		lInfo.logln('search for ' + odSMArray[iIndex].getPath() + '/capabilities/temperature-control');
		if (Property.getProperty(odSMArray[iIndex].getPath() + '/capabilities/temperature-control')) {
			lInfo.logln('found dsm with temperature control ' + odSMArray[iIndex].getChild('dSUID').getValue());
			oPossibleCircuits.push(odSMArray[iIndex].getChild('dSUID').getValue());
		}

	}
	var pidPossible = {};
	for ( var iIndex = 0; iIndex < oPossibleCircuits.length; iIndex++) {
		var dsm = oPossibleCircuits[iIndex];
		pidPossible[dsm] = 0;
		lInfo.logln('looking at ' + dsm);
		if (Property.getNode('/apartment/dSMeters/' + dsm + '/zones') != null) {
			lInfo.logln('dsm ' + dsm + ' has zone node ...');
			var oDSMZoneNode = Property.getNode('/apartment/dSMeters/' + dsm + '/zones').getChildren();
			lInfo.logln('dsm ' + dsm + ' has zone node count ' + oDSMZoneNode.length);
			for ( var jIndex = 0; jIndex < oDSMZoneNode.length; jIndex++) {
				lInfo.logln('check dsm ' + oPossibleCircuits + ' if zone ' + zoneID + ' is registered');
				if (zoneID == oDSMZoneNode[jIndex].getChild('ZoneID').getValue()) {
					if (pidCircuits[zoneID] == null)
						pidCircuits[zoneID] = [];
					pidPossible[dsm]++;
					pidCircuits[zoneID].push(dsm);
				}
			}
		} else {
			lInfo.logln('no zones on meter ' + dsm)
		}
	}
	if (pidCircuits[zoneID] != null)
		if (pidCircuits[zoneID][0] != null) {
			lInfo.logln('returning dsm ' + pidCircuits[zoneID][0]);
			return pidCircuits[zoneID][0];
		}
	return null;
}

function preventUninstall() {
	var fPrevent=false;
    var oZoneArray=Property.getNode('/apartment/zones').getChildren();
    for (var iIndex=0;iIndex<oZoneArray.length;iIndex++) {
    	var iZoneID=oZoneArray[iIndex].getChild('ZoneID').getValue();
    	if (iZoneID!=0) {
    		var zZone = getZoneByID(iZoneID);    		
    		var oldConfig = zZone.getTemperatureControlConfiguration();
    		if (oldConfig.IsConfigured)
	    		if (oldConfig.ControlMode != 0) {
	    		    Property.setProperty('system/preventUninstall',true);
	    		    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
	    		    return;
	    		}    		
    	}
    }
    Property.setProperty('system/preventUninstall',false);
    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
}

if (raisedEvent.name == 'heating-controller.controller-config') {
	if (raisedEvent.parameter.actions == 'sync') {
	}
	if (raisedEvent.parameter.actions == 'resetControllerMode') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var zZone = getZoneByID(parseInt('' + zoneID, 10));

			/*
			 * oParameter.ControlMode = oDataObject.controllerMode;
			 * oParameter.id = iZoneID;
			 * 
			 * oParameter.CtrlDSUID = me.getDSMPIDForZone(iZoneID);
			 * oParameter.ControlDSUID = me.getDSMPIDForZone(iZoneID);
			 */

			var dSM = getDSMPIDForZone(zoneID)
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : -1
				}).raise();
			} else {
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : 0
				});

				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', 0);

				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : 0
				}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModePID') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID)
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : -1
				}).raise();
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = ((oldConfig.ControlMode != 1) && (oldConfig.ControlMode != 4));

				var oParameter = {
					ControlMode : 1,
					EmergencyValue : 75
				}
				if (raisedEvent.parameter.emergency!=null)
					oParameter.EmergencyValue=raisedEvent.parameter.emergency;

				
				oParameter.CtrlKp = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/kp'));
				oParameter.CtrlTs =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ts'));
				oParameter.CtrlTi =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ti'));
				oParameter.CtrlKd =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/kd'));
				oParameter.CtrlImin = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/imin'));
				oParameter.CtrlImax = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/imax'));
				oParameter.CtrlYmin = Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ymin');
				oParameter.CtrlYmax = Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ymax');
				oParameter.CtrlAntiWindUp = ((Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/antiwindup')!=0)?true:false);
				oParameter.CtrlKeepFloorWarm = ((Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/keepfloorwarm')!=0)?true:false);
				zZone.setTemperatureControlConfiguration(dSM, oParameter);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', raisedEvent.parameter.definitionID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue', oParameter.EmergencyValue);
				
				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');
					zZone.setTemperatureControlValues(defaultTemperatureValues, defaultTemperatureValues);
				}
				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : 0
				}).raise();

				// new
				// Event('HeatingControllerSetup',{'zoneID':zoneID,'HeatingControllerTypeId':raisedEvent.parameter.definitionID}).raise();
				var handle = new WebserviceConnection();
				var queryString='heatingControllerTypeId=' + raisedEvent.parameter.definitionID + '&zoneid=' + raisedEvent.parameter.zoneID+ '&dSSId=' + getMyDSID();
				lInfo.logln('public/dss/v1_1/DSSHeating/SetHeatingControllerType ' + queryString)
				handle.request('public/dss/v1_1/DSSHeating/SetHeatingControllerType',queryString , 'POST', {
					'Content-Type' : 'application/json',
					'NotificationTextIsUrlEncodedUtf7' : 'true'
				}, '', true, function(code, retdata) {
					if (code === 200) {
						lInfo.logln(': OK [' + code + ']');
					} else {
						lWarn.logln(': FAILED! Server replied: "' + code + '"');
					}
					lInfo.logln(retdata);
				});
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeZoneFollower') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID)
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : -1
				}).raise();
			} else {
				var offset = raisedEvent.parameter.offset;
				var followedZone = raisedEvent.parameter.followedZone;
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oParameter ={
					ControlMode : 2,
					ReferenceZone : followedZone,
					CtrlOffset : offset,
					EmergencyValue : 75
				}
				if (raisedEvent.parameter.emergency!=null)
					oParameter.EmergencyValue=raisedEvent.parameter.emergency;

				zZone.setTemperatureControlConfiguration(dSM, oParameter);
				
				
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', -2);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/offset', offset);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/followedZone', followedZone);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue', oParameter.EmergencyValue);

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : 0
				}).raise();				
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeFixedValue') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID)
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : -1
				}).raise();
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = ((oldConfig.ControlMode != 3) && (oldConfig.ControlMode != 4));
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : 3
				});

				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', -3);

				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');
					zZone.setTemperatureControlValues(defaultFixedValues, defaultFixedValues);
				}

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : 0
				}).raise();
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeManual') {
		Property.load();
		try {
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/fManualOverride', true);
			var manualValue = 0;
			if (raisedEvent.parameter.value != null)
				manualValue = parseInt('' + raisedEvent.parameter.value, 10);
			var zZone = getZoneByID(parseInt('' + raisedEvent.parameter.zoneID, 10));
			lInfo.logln('setControllerModeManual for zone ' + raisedEvent.parameter.zoneID);
			var dSM = getDSMPIDForZone(raisedEvent.parameter.zoneID);
			zZone.setTemperatureControlConfiguration(dSM, {
				ControlMode : 4,
				ManualValue : manualValue
			});
			Property.store();
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();			
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'checkPreventUninstall') {
		preventUninstall();
        Property.store();
	}
	if (raisedEvent.parameter.actions == 'resetControllerModeManual') {
		Property.load();
		try {

			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/fManualOverride', false);
			Property.store();

			if (Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID') == null) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID') == 0) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID') == -2) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to zoneFollower');
				var offset = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/offset');
				var followedZone = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/followedZone');
				var emergenyValue = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue');
				
				
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModeZoneFollower',
					'offset' : offset,
					'followedZone' : followedZone,
					'emergency': emergenyValue
				}).raise();
			} else if (Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID') == -3) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to fixedValue');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModeFixedValue',
				}).raise();
			} else {
				var definitionID = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID');
				var emergenyValue = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue');
				
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to PID with definition ' + definitionID);
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModePID',
					'definitionID' : definitionID,
					'emergency': emergenyValue
				}).raise();
			}
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
}